package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DammtiPianiFerieController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DammtiPianiFerieDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DammtiPianiFerie;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DmotivazioniAlertPfController;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DpianiFerieController;

@Component
public class DammtiPianiFerieModelAssembler
		extends BaseModelAssembler<DammtiPianiFerie, DammtiPianiFerieDto, DammtiPianiFerieController> {

	@Override
	public DammtiPianiFerieDto toModel(DammtiPianiFerie dammtiPianiFerie) {
		DammtiPianiFerieDto dammtiPianiFerieDto = map(dammtiPianiFerie, DammtiPianiFerieDto.class,
				DammtiPianiFerieController.class);

		// SELF LINK
		Link selfLink = convert(
				linkTo(methodOn(DammtiPianiFerieController.class).getByObjectKey(dammtiPianiFerie.getObjectKey()))
						.withSelfRel());
		dammtiPianiFerieDto.add(selfLink);

		// PARENT LINKS
		if (dammtiPianiFerie.getTheDmotivazioniAlertPf() != null) {
			Link dmotivazioniAlertPfLink = convert(linkTo(methodOn(DmotivazioniAlertPfController.class)
					.getByObjectKey(dammtiPianiFerie.getTheDmotivazioniAlertPfObjectKey()))
							.withRel("theDmotivazioniAlertPf"));
			dammtiPianiFerieDto.add(dmotivazioniAlertPfLink);
		}
		if (dammtiPianiFerie.getTheDpianiFerie() != null) {
			Link dpianiFerieLink = convert(linkTo(
					methodOn(DpianiFerieController.class).getByObjectKey(dammtiPianiFerie.getTheDpianiFerieObjectKey()))
							.withRel("theDpianiFerie"));
			dammtiPianiFerieDto.add(dpianiFerieLink);
		}

		// CHILDREN LINKS

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return dammtiPianiFerieDto;

	}

	@Override
	public CollectionModel<DammtiPianiFerieDto> toCollectionModel(Iterable<? extends DammtiPianiFerie> entities) {
		CollectionModel<DammtiPianiFerieDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

